<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 77 Pizza365 CRUD</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Admin Page</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/hinhtui.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Huy Nguyen 18+</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="voucher.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Voucher CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="menu.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menu CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="drink.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drink CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="country.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="region.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Region CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="user.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Country - Region - CRUD</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Regions Manage</h2>
        <div class="row">
        <!--<div class="col-sm-12">
          <button id="btn-clear-data" class="btn btn-danger">Delete All Data</button>
        </div>-->
        </div>
        <div class="jumbotron container">
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="region-code">Mã Khu vực</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-region-code" name="region-code" placeholder="region code"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
          <div class="col-sm-3">
            <label for="region-name">Tên Khu vực</label>
          </div>
          <div class="col-sm-9">
            <input type="text" id="input-region-name" name="region-name" placeholder="region name"
            class="form-control">
          </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="country">Quốc Gia</label>
            </div>
            <div class="col-sm-9">
              <select type="text" id="select-country" name="country" placeholder="country name"
              class="form-control">
                <option value=0>Chọn quốc gia</option>
              </select>
            </div>
          </div>
          
          <div class="row pull-right">
            <div class="col-sm-3">
            </div>
            <div class="col-sm-9">
              <div class ="row">
                <div class="col-sm-3">
                  <button id="btn-update-region" class="btn btn-info w-100"><i class="fas fa-edit"></i>&nbsp;Update</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-delete-region" class="btn btn-danger w-100"><i class="fas fa-trash"></i>&nbsp;Delete</button>
                </div>
                <div class="col-sm-3">
                  <button id="btn-create-region" class="btn btn-success w-100"><i class="fa fa-plus"></i>&nbsp;Add New</button>
                </div>
                <div class = "col-sm-3">
                  <button id="btn-cancel" class="btn btn-secondary w-100">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Mã khu vực</th>
              <th>Tên khu vực</th>
            </tr>
        </table>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
// Biến toàn cục để lưu trữ id region đang đc update or delete. Mặc định = 0;
var gRegionId = 0;
var gCountryId = 0;
var gCountryArr = [];
const gBASE_URL = "http://localhost:8080/regions";
const gCONTENT_TYPE = "application/json;charset=UTF-8";
var gCountrySelectElement = $("#select-country");

$(document).ready(function(){
  var table = $("#user-table").DataTable({
    "columns": [
      {"data":"id"},
      {"data":"regionCode"},
      {"data":"regionName"},
    ]
  })
  loadDataToTable();
	
  //Get data country
  $.ajax({
    url: "http://localhost:8080/countries",
    method: "GET",
    success: function(pObjRes) {
      gCountryArr = pObjRes;
      console.log(gCountryArr);
      loadDataToCountrySelect(pObjRes);
    },
    error: function(paramErr) {
      console.log(paramErr.responseText);
    }
  });

		
	/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
	//Subtask 1- add click event to all rows
	$("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update region: add event to save data button
	$("#btn-update-region").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new region
	$("#btn-create-region").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete region selected
	$("#btn-delete-region").on("click",function(){
		onDeleteButtonClick();
	});
	//task 5 - Cancel
	$("#btn-cancel").on("click",function(){
		onCancelBtnClick();
	});

	/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
	//hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gRegionId = $(paramRow).find("td:eq(0)").html();
    gCountryId = getCountryIdByRegionId(gRegionId);
		console.log("Region id of selected row: " + gRegionId);
		//lấy thông tin region của row được click và hiển thị lên form
		var vRegion = callApiGetRegionById(gRegionId);
	};
	
	//hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo region obj
		var vRegionObj = {
			regionCode: "",
			regionName: "",
      country: -1
		}
		// B1: Thu thập dữ liệu
		getUpdateRegionData(vRegionObj);
		// B2: Validate update
		var vIsRegionValid = validateRegionData(vRegionObj);
    	if (vIsRegionValid){
			// B3: update region
			$.ajax({
				url: "http://localhost:8080/countries/" + gCountryId + "/regions/"+ gRegionId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vRegionObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateRegionSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm region
	function onCreateButtonClick(){
		//khai báo region obj
		var vRegionObj = {
			regionCode: "",
			regionName: "",
      country: -1
		}
		// B1: Thu thập dữ liệu
		getUpdateRegionData(vRegionObj);
		// B2: Validate data
		var vIsRegionValid = validateRegionData(vRegionObj);
    	if (vIsRegionValid){
			// B3: create region
			$.ajax({
				url: "http://localhost:8080/countries/" + vRegionObj.country + "/regions",
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vRegionObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateRegionSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa region được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: "http://localhost:8080/countries/" + gCountryId +"/regions/"+ gRegionId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteRegionSuccess();
        },
        error: function(paramErr) {
          alert("Xóa region không thành công");
        }
      });
	}
  function onCancelBtnClick(){
    $("#input-region-code").val("");
		$("#input-region-name").val(""); 
		$("#select-country").val(0); 
	}

	/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //lấy country id từ region id
  function getCountryIdByRegionId(paramId){
    for (let i=0; i<gCountryArr.length; i++){
      var vCountryRegions = gCountryArr[i].regions;
      for (let j=0; j< vCountryRegions.length; j++){
        if (paramId == vCountryRegions[j].id){
          gCountryId = gCountryArr[i].id;
          console.log("Country id of selected region: " + gCountryId);
        }
      }
    }
    return gCountryId;
  }
  function loadDataToTable(){
    $.ajax({
		url: gBASE_URL,
		type: "GET",
		dataType: "json",
		success: function(res){
			console.log(res);
			table.clear();
			table.rows.add(res);
			table.draw();
		},
		error: function(err){
			console.log(err.response);
		}
	})
  };
  //load data to country select
  function loadDataToCountrySelect(pCountryList) {
    for (let i = 0; i < pCountryList.length; i++) {
      var bCountryOption = $("<option/>");
      bCountryOption.prop("value", pCountryList[i].id);
      bCountryOption.prop("text", pCountryList[i].countryName);
      gCountrySelectElement.append(bCountryOption);
    };
  }

	//hàm gọi API lấy thông tin region của dòng được chọn
	function callApiGetRegionById(paramId){
    
		$.ajax({
			url: "http://localhost:8080/countries/" + gCountryId +"/regions/"+ paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayRegionData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
  
	//hàm hiển thị thông tin region của dòng được click
	function displayRegionData(paramRegion){
		$("#input-region-code").val(paramRegion.regionCode);
		$("#input-region-name").val(paramRegion.regionName);
    $("#select-country").val(gCountryId);
	}
	// hàm thu thập dữ liệu để update region
	function getUpdateRegionData(paramRegionObj) {
		paramRegionObj.regionCode = $("#input-region-code").val().trim();
		paramRegionObj.regionName = $("#input-region-name").val().trim();
    paramRegionObj.country = $("#select-country").val();
	}

	// hàm validate data
	function validateRegionData(paramRegionObj) {
		if (paramRegionObj.regionCode === "") {
		alert("Cần nhập mã region");
		return false;
		}
		if (paramRegionObj.regionName === "") {
		alert("Cần nhập tên region");
		return false;
		}

		return true;
	}
	
	//hiển thị cập nhật region thành công
	function handleUpdateRegionSuccess(){
		alert("Sửa region có id: " + gRegionId + " thành công!");
    loadDataToTable();
	};
	//hiển thị thêm region thành công
	function handleCreateRegionSuccess(){
		alert("Thêm region thành công!");
    loadDataToTable();
	};
	//hiển thị cập nhật region thành công
	function handleDeleteRegionSuccess(){
		alert("Xóa region có id: " + gRegionId + " thành công!");
    loadDataToTable();
	};
})
</script>
</body>
</html>
